from guizero import App, Box, Text, TextBox, PushButton, Drawing, MenuBar, Combo
from os.path import exists
import math, configparser, serial, serial.tools.list_ports

def help_about():
    app.info("About Rotor Controller", "Python Rotor Controller 1.1 by N3OC")

def set_port():
    global port, ser, baud, timeout
    print('setting serial port:' + port + ' baud:' + baud + ' timeout:' + timeout)
    try:
        ser.is_open==True
        ser.close()
    except:
        print('serial port is closed')
    try:
        ser = serial.Serial(port, baud, timeout=.1)
    except:
        print('invalid serial port chosen')
    config['PORT'] = {'ComPort': port, 'baud': baud, 'timeout': timeout}
    with open('rotorconfig.ini', 'w') as configfile:
        config.write(configfile)

def set_baud():
    print('set baud clicked')
    global baud
    baud = app.question("Baud Rate", "Enter baud rate.\nValid entries are 300, 1200, 2400, 4800, 9600")
    # If cancel is pressed, None is returned
    # so check a name was entered
    if baud == '300' or baud == '1200' or baud == '2400' or baud == '4800' or baud == '9600':
        print('valid baud entered:' + baud)
        set_port()
    else:
        if baud is not None:
            app.info("Select Baud Rate", "Invalid entry for baud rate.")

def set_timeout():
    #this is broken, can't set timeout yet and don't forget to update config file here
    print('set timeout clicked')
    global timeout
    timeout = app.question("Serial Port Timeout", "Enter serial port timeout value in seconds.\nRecommended values are .1 - 1")
    if timeout is not None:
        print('timeout entered:' + timeout)
        set_port()

def set_polling():
    print('set timeout clicked')
    global poll
    poll = app.question("Polling Interval", "Enter polling interval in milliseconds.\nRecommended value is 1000 (1 sec).\nProgram restart required to take effect.")
    if timeout is not None:
        if int(poll) >= 500:
            print('poll entered:' + poll)
            config['POLLING'] = {'PollInterval': poll}
            with open('rotorconfig.ini', 'w') as configfile:
                 config.write(configfile)
        else:
            app.info("Polling Interval Error", "Polling interval lesss than 500ms not allowed.")

def set_preset1():
    print('set preset1 clicked')
    global preset1
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset1 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset1.text = preset1
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset2():
    print('set preset2 clicked')
    global preset2
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset2 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset2.text = preset2
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset2():
    print('set preset2 clicked')
    global preset2
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset2 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset2.text = preset2
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset3():
    print('set preset3 clicked')
    global preset3
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset3 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset3.text = preset3
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset4():
    print('set preset4 clicked')
    global preset4
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset4 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset4.text = preset4
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset5():
    print('set preset5 clicked')
    global preset5
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset5 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset5.text = preset5
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset6():
    print('set preset6 clicked')
    global preset6
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset6 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset6.text = preset6
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset7():
    print('set preset7 clicked')
    global preset7
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset7 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset7.text = preset7
    else:
        app.info("Enter new preset.", "Invalid preset entry.")
    
def set_preset8():
    print('set preset8 clicked')
    global preset8
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset8 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset8.text = preset8
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset9():
    print('set preset9 clicked')
    global preset9
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset9 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset9.text = preset9
    else:
        app.info("Enter new preset.", "Invalid preset entry.")

def set_preset10():
    print('set preset10 clicked')
    global preset10
    preset = app.question("Enter new preset.", "Enter new preset.\nValid entries are 0-359.")
    if int(preset) >= 0 and int(preset) <= 359:
        preset10 = str(preset.zfill(3))
        config['PRESETS'] = {'preset1': preset1, 'preset2': preset2, 'preset3': preset3,  'preset4': preset4,
                             'preset5': preset5, 'preset6': preset6, 'preset7': preset7, 'preset8': preset8,
                             'preset9': preset9, 'preset10': preset10}
        with open('rotorconfig.ini', 'w') as configfile:
             config.write(configfile)
        pset10.text = preset10
    else:
        app.info("Enter new preset.", "Invalid preset entry.")
            
#windows com ports

def port_com1():
    global port
    port = "com1"
    set_port()
    
def port_com2():
    global port
    port = "com2"
    set_port()
    
def port_com3():
    global port
    port = "com3"
    set_port()

def port_com4():
    global port
    port = "com4"
    set_port()

def port_com5():
    global port
    port = "com5"
    set_port()
    
def port_com6():
    global port
    port = "com6"
    set_port()

def port_com7():
    global port
    port = "com7"
    set_port()

def port_com8():
    global port
    port = "com8"
    set_port()

def port_com9():
    global port
    port = "com9"
    set_port()

def port_com10():
    global port
    port = "com10"
    set_port()

def port_com11():
    global port
    port = "com11"
    set_port()

def port_com12():
    global port
    port = "com12"
    set_port()

def port_com13():
    global port
    port = "com13"
    set_port()

def port_com14():
    global port
    port = "com14"
    set_port()

def port_com15():
    global port
    port = "com15"
    set_port()

def port_com16():
    global port
    port = "com16"
    set_port()

#raspberry pi com ports
    
def port_USB0():
    global port
    port = "/dev/ttyUSB0"
    set_port()

def port_USB1():
    global port
    port = "/dev/ttyUSB1"
    set_port()

#rotor types
    
def type_rotorez():
    print("type_rotorez clicked")
    global type
    type='RotorEZ'
    config['ROTOR'] = {'RotorType': 'RotorEZ'}
    with open('rotorconfig.ini', 'w') as configfile:
        config.write(configfile)

def type_yaesu():
    print("type_yaesu clicked")
    global type
    type='Yaesu'
    config['ROTOR'] = {'RotorType': 'Yaesu'}
    with open('rotorconfig.ini', 'w') as configfile:
        config.write(configfile)

def update():
    #get hdg from updatebox text box, format it for leading zeroes and send to rotor
    if type=='RotorEZ':
        hdg = "AP1"+(updatebox.value.zfill(3))+"\r"
    if type=='Yaesu':
        hdg = "M"+(updatebox.value.zfill(3))+"\r"
    print("rotor command sent: "+hdg)
    #encode hdg to bytes
    output=hdg.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def read_rotor():
    global ser
    if type=='RotorEZ':
        read_command="AI1;"
    if type=='Yaesu':
        read_command="C\r"
    send=read_command.encode('utf-8')
    #use try for all these items that throw errors when the com port isn't open
    #or the rotor is not responding to polls
    try:
        ser.write(send)
    except:
        print('serial port not open error1')
        heading.value="999"
        heading.bg="red"
        heading.hide_text=True
    if type=='RotorEZ':
        try:
            read=ser.read(4)
        except:
            print('serial port read error1')
        heading.value="999"
        heading.bg="red"
        heading.hide_text=True
    if type=='Yaesu':
        try:
            #read=ser.read(7)
            read=ser.readline()
        except:
            print('serial port read error2')
        heading.value="999"
        heading.bg="red"
        heading.hide_text=True
    #print(read)
    try:
        read=read.decode('utf-8')
    except:
        print('rotor read error1')
        heading.value="999"
        heading.bg="red"
        heading.hide_text=True
    if type=='RotorEZ':
        try:
            readh=read[1:4]
        except:
            print('rotor read error2')
            heading.value="999"
            heading.bg="red"
            heading.hide_text=True
    if type=='Yaesu':
        try:
            readh=read[2:6]
        except:
            print('rotor read error3')
            heading.value="999"
            heading.bg="red"
            heading.hide_text=True
    #print(readh)
    #test for blank readh if rotor if above calculations fail or if rotor not responding
    try:
        if readh=="":
            print("serial port read error3")
            heading.value="999"
            heading.bg="red"
            heading.hide_text=True
    except:
        print('serial port not open error2')
    #read OK, continue
    else:
        #print(read)
        #hackage here when the ezrotor box resets, my read gets confused so reset it
        if ';' in readh:
            print("rotor read error4")
            readh=""
            ser.close()
            ser = serial.Serial(port, baud, timeout=.1)
            ser.write(send)
            read=ser.read(4)
            #print(read)
            readh=read[1:4]
            #all better now, continue
        #update the heading in the text box
        heading.value=readh
        heading.bg="white"
        heading.hide_text=False
        #convert readh to int so draw math can work
        try:
            h=int(readh)
        except:
            print('rotor read error5')
            heading.value="999"
            heading.bg="red"
            heading.hide_text=True
            h=0
        print("rotor bearing read: "+str(h))
        #debug print entry values
        print("x=",x," y=",y," z=",z," h=",h," r=",r," color=",color)
        #convert math here
        #fix h off by 90, due to trig using right triangle 90 degrees offset from zero
        h=h-90
        x1=(r*(math.cos(math.radians(h))))
        y1=(r*(math.sin(math.radians(h))))
        #add offset for circle center (which is z/2 or r) and round to two places
        x1=round((x1+r),2)
        y1=round((y1+r),2)
        #debug print azimuth line calculated endpoints
        print("x1=",x1," y1=",y1)
        #draw circle and azimuth line
        oval=drawing.oval(x,y,z,z,color)
        line=drawing.line(r,r,x1,y1,color="red",width=2)
        #I do note the ID changes every time you draw a new one on top of the old one
        #have not been able to figure out how to avoid this, maybe it's harmless
        #but it bothers me it just keeps incrementing the ID forever, every loop here draws a new
        #instance over top of the old one, and increments the drawing ID numbers. I'd like to figure
        #out how to erase or destroy the previous drwing but nothing works so far
        print("circle ID=",oval," line ID=",line)

def stop():
    if type=='RotorEZ':
        stop_cmd = ";"
    if type=='Yaesu':
        stop_cmd = "A\r"
    print("rotor command sent: "+stop_cmd)
    #encode hdg to bytes
    output=stop_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

#presets here

def send_preset1():
    print('preset1 clicked')
    global preset1
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset1 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset1 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset2():
    print('preset2 clicked')
    global preset2
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset2 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset2 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset3():
    print('preset3 clicked')
    global preset3
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset3 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset3 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset4():
    print('preset4 clicked')
    global preset4
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset4 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset4 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset5():
    print('preset5 clicked')
    global preset5
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset5 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset5 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset6():
    print('preset6 clicked')
    global preset6
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset6 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset6 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset7():
    print('preset7 clicked')
    global preset7
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset7 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset7 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')
    
def send_preset8():
    print('preset8 clicked')
    global preset8
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset8 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset8 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset9():
    print('preset9 clicked')
    global preset9
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset9 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset9 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')

def send_preset10():
    print('preset10 clicked')
    global preset10
    if type=='RotorEZ':
       ps_cmd = 'AP1' + preset10 + '\r'
    if type=='Yaesu':
       ps_cmd = 'M' + preset10 + '\r'
    print("rotor command sent: "+ps_cmd)
    #encode hdg to bytes
    output=ps_cmd.encode('utf-8')
    #output the encoded result to the com port
    try:
        ser.write(output)
    except:
        print('serial port write error')
    
def exit():
    app.destroy()

#set up App object
app = App(title="Rotor Controller",height=220, width=450,bg=(0, 218, 125))

#set up Box objects, this just helps guizero place objects where you want them since it does
#not support absolute positioning (brain dead)
azimuth_box = Box(app, align="right")
update_box = Box(app, align="left")
button_box = Box(app, layout="grid")

#set up config file using configparser
config = configparser.ConfigParser()
#see if config file exists, if not, make one
if exists('rotorconfig.ini')==False:
    print('no config file found, creating one now')
    config['PORT'] = {'ComPort': '0', 'baud': '4800', 'timeout': '.1'}
    config['ROTOR'] = {'RotorType': 'RotorEZ'}
    config['POLLING'] = {'PollInterval': '1000'}
    config['PRESETS'] = {'preset1': '330', 'preset2': '315', 'preset3': '270', 'preset4': '230', 'preset5': '215',
                         'preset6': '000', 'preset7': '045', 'preset8': '090', 'preset9': '150', 'preset10': '179'}
    with open('rotorconfig.ini', 'w') as configfile:
        config.write(configfile)

#read in the config file values
try:
    config.read('rotorconfig.ini')
    port = config['PORT']['ComPort']
    baud = config['PORT']['baud']
    timeout = config['PORT']['timeout']
    preset1 = config['PRESETS']['preset1']
    preset2 = config['PRESETS']['preset2']
    preset3 = config['PRESETS']['preset3']
    preset4 = config['PRESETS']['preset4']
    preset5 = config['PRESETS']['preset5']
    preset6 = config['PRESETS']['preset6']
    preset7 = config['PRESETS']['preset7']
    preset8 = config['PRESETS']['preset8']
    preset9 = config['PRESETS']['preset9']
    preset10 = config['PRESETS']['preset10']
    poll = config['POLLING']['PollInterval']
    type = config['ROTOR']['RotorType']
except:
    app.warn("ini File Error", "Error reading ini file. Please delete the rotorconfig.ini file & restart program to create a new one.")
    app.destroy()
#set up MenuBar widget, move this to tkinter menu later since it supports menu checkboxes and guizero does not (brain dead)
menubar = MenuBar(app, toplevel=["Com Port", "Settings", "Rotor Type", "Change Presets", "Help"],
                  options=[
                      [ ["Com1", port_com1], ["Com2", port_com2], ["Com3", port_com3], ["Com4", port_com4], ["Com5", port_com5],
                        ["Com6", port_com6], ["Com7", port_com7], ["Com8", port_com8], ["Com9", port_com9], ["Com10", port_com10],
                        ["Com11", port_com11], ["Com12", port_com12], ["Com13", port_com13], ["Com14", port_com14], ["Com15", port_com15],
                        ["Com16", port_com16], ["/dev/ttyUSB0", port_USB0], ["/dev/ttyUSB1", port_USB1] ],
                      [ ["Set Baud Rate", set_baud], ["Set Port Timeout", set_timeout], ["Set Polling Interval", set_polling] ],
                      [ ["RotorEZ/DCU-1", type_rotorez], ["Yaesu/EA4TX (azimuth only)", type_yaesu] ],
                      [ ["Preset 1 "+preset1, set_preset1], ["Preset 2 "+preset2, set_preset2], ["Preset 3 "+preset3, set_preset3], ["Preset 4 "+preset4, set_preset4],
                        ["Preset 5 "+preset5, set_preset5], ["Preset 6 "+preset6, set_preset6], ["Preset 7 "+preset7, set_preset7], ["Preset 8 "+preset8, set_preset8],
                        ["Preset 9 "+preset9, set_preset9], ["Preset 10 "+preset10, set_preset10] ],
                      [ ["About", help_about] ]
                      ])

#set up the drawing widget
drawing=Drawing(azimuth_box, align="top")
#x,y are circle origin, z is diameter
x=0
y=0
z=100
#since circle is z diameter, radius is (z+x)/2
r=(z+x)/2
#h=heading, text degrees read from rotor, h will be type int
#circle color
color=(0, 151, 214)
#set up text boxes with initial azimuth of 0 on program start
heading = TextBox(azimuth_box, text="0", width=3)
updatebox = TextBox(update_box, width=3)
heading.text_size=18
heading.bg="white"
updatebox.text_size=18
updatebox.bg="white"
updatebox.focus()
h=int(heading.value)

#set up push buttons
update=PushButton(update_box, command=update,text="Turn")
stop=PushButton(update_box, command=stop,text="Stop")
close=PushButton(update_box, command=exit, text="Exit")
pset1=PushButton(button_box, command=send_preset1, text=preset1, grid=[0,0])
pset2=PushButton(button_box, command=send_preset2, text=preset2, grid=[0,1])             
pset3=PushButton(button_box, command=send_preset3, text=preset3, grid=[0,2])
pset4=PushButton(button_box, command=send_preset4, text=preset4, grid=[0,3])
pset5=PushButton(button_box, command=send_preset5, text=preset5, grid=[0,4])
pset6=PushButton(button_box, command=send_preset6, text=preset6, grid=[1,0])
pset7=PushButton(button_box, command=send_preset7, text=preset7, grid=[1,1])
pset8=PushButton(button_box, command=send_preset8, text=preset8, grid=[1,2])
pset9=PushButton(button_box, command=send_preset9, text=preset9, grid=[1,3])
pset10=PushButton(button_box, command=send_preset10, text=preset10, grid=[1,4])

#test for valid com port and prompt to enter one if 0, if not 0, set up the com port
print("port in config file=",port)
if port=="0":
    #app.warn("Select Com Port", "Please select a com port first.")
    ports = serial.tools.list_ports.comports()
    loop=0
    portlist = []
    for port, desc, hwid in sorted(ports):
        portsfound=print("{}: {} [{}]".format(port, desc, hwid))
        portlist.insert(loop, port)
        loop=loop+1
    if len(portlist)==0:
        print('no com ports found')
        app.warn("No Com Ports", "No com ports found on this system!")
    else:
        app.warn("Select Com Port", "Please select a com port first.\rAvailable ports are: "+str(portlist))
else:
    #hangs here when program started with invalid serial port in ini file so I put in a try
    try:
        ser = serial.Serial(port, baud, timeout=.1)
    except:
        print("invalid com port on startup")
        ports = serial.tools.list_ports.comports()
        loop=0
        portlist = []
        for port, desc, hwid in sorted(ports):
            portsfound=print("{}: {} [{}]".format(port, desc, hwid))
            portlist.insert(loop, port)
            loop=loop+1
        if len(portlist)==0:
            print('no com ports found')
            app.warn("No Com Ports", "No com ports found on this system!")
        else:
            app.warn("Select Com Port", "Please select a com port first.\rAvailable ports are: "+str(portlist))
  
#read the rotor box here, repeating at poll interval
rotor = Text(app, text="")
rotor.repeat(poll, read_rotor)

app.display()

